package com.ruoyi.web.base.controller;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.framework.web.service.TokenService;
import com.ruoyi.web.base.domain.BaseCustomerChannel;
import com.ruoyi.web.base.service.IBaseCustomerChannelService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

import static com.ruoyi.common.core.domain.AjaxResult.success;
import static com.ruoyi.common.utils.SecurityUtils.getUsername;

/**
 * <p>
 * 客户渠道 前端控制器
 * </p>
 *
 * @author author
 * @since 2026-02-03
 */
@RestController
@RequestMapping("/base-customer-channel")
public class BaseCustomerChannelController {
    @Autowired
    private IBaseCustomerChannelService customerChannelService;
    @Autowired
    private TokenService tokenService;

    @ApiOperation("客户渠道管理添加")
    @PostMapping("/add")
    public AjaxResult add(@RequestBody BaseCustomerChannel baseCustomerChannel, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (customerChannelService.count(new QueryWrapper<BaseCustomerChannel>().eq("org_id",loginOrgId).eq("customer_num", baseCustomerChannel.getCustomerNum())) >0 ){
            throw new Exception("该编号已存在");
        }
        baseCustomerChannel.setOrgId(loginOrgId);
        baseCustomerChannel.setCreateBy(getUsername());
        return success(customerChannelService.save(baseCustomerChannel));
    }

    @ApiOperation("客户渠道管理修改")
    @PostMapping("/edit")
    public AjaxResult edit(@RequestBody BaseCustomerChannel baseCustomerChannel, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (customerChannelService.count(new QueryWrapper<BaseCustomerChannel>().ne("id",baseCustomerChannel.getId()).eq("org_id",loginOrgId).eq("customerr_num", baseCustomerChannel.getCustomerNum())) >0 ){
            throw new Exception("该编号已存在");
        }
        baseCustomerChannel.setUpdateBy(getUsername());
        return success(customerChannelService.updateById(baseCustomerChannel));
    }

    @ApiOperation("客户渠道管理删除")
    @PostMapping("/delete")
    public AjaxResult delete(@RequestBody Map<String, String> paramsMap) {
        String ids = paramsMap.get("ids");
        for (String s : ids.split(",")) {
            customerChannelService.removeById(s);
        }
        return success();
    }

    @ApiOperation("客户渠道管理列表")
    @PostMapping("/list")
    public AjaxResult listAll( HttpServletRequest request){
        return success(customerChannelService.list(new QueryWrapper<BaseCustomerChannel>().eq("org_id",tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("客户渠道管理分页")
    @GetMapping("/page")
    public AjaxResult page(@RequestParam("pageNum") Integer pageNum, @RequestParam("pageSize") Integer pageSize,HttpServletRequest request
    ) {
        return success(customerChannelService.page(new Page<BaseCustomerChannel>(pageNum,pageSize),new QueryWrapper<BaseCustomerChannel>().eq("org_id",tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("客户渠道管理详情")
    @PostMapping("/listById")
    public AjaxResult listById(@RequestBody Map<String, String> paramsMap){
        String id = paramsMap.get("id");
        return success(customerChannelService.getById(id));
    }
}
